/************************************************************************************
gpsserviceirs
Copyright (c) 2010, International Rescue System Institute
All rights reserved.

Contact us if you use this software for sell.
If you use this software not for sell, you can use this software under BSD license.
See the files LICENSE.TXT and LICENSE-BSD.TXT for more details.                     
************************************************************************************/

#ifndef GPSSERVICE_H
#define GPSSERVICE_H

#include <rtm/Manager.h>
#include <rtm/DataFlowComponentBase.h>
#include <rtm/CorbaPort.h>
#include <rtm/DataInPort.h>
#include <rtm/DataOutPort.h>
#include <rtm/idl/BasicDataTypeSkel.h>

// Service implementation headers
// <rtc-template block="service_impl_h">

// </rtc-template>


//-- [ヘッダファイル] --------------------------------------------------------------------------//
#include "legacy.h"											// legacyヘッダファイル読み込み
#include <math.h>											// mathヘッダファイル読み込み
//----------------------------------------------------------------------------------------------//


//-- [置換] ------------------------------------------------------------------------------------//
#define DEBUG_CONFIGURATION										// DEBUG定義 [デバッグ用]
#define DEBUG_TIMESTAMP											// DEBUG定義 [デバッグ用]
#define DEBUG_CHECKSUM											// DEBUG定義 [デバッグ用]
#define DEBUG_MODE											// DEBUG定義 [デバッグ用]
#define DEBUG_GGA											// DEBUG定義 [デバッグ用]
#define DEBUG_GLL											// DEBUG定義 [デバッグ用]
#define DEBUG_GNS											// DEBUG定義 [デバッグ用]
#define DEBUG_GRS											// DEBUG定義 [デバッグ用]
#define DEBUG_GSA											// DEBUG定義 [デバッグ用]
#define DEBUG_GST											// DEBUG定義 [デバッグ用]
#define DEBUG_GSV											// DEBUG定義 [デバッグ用]
#define DEBUG_HDT											// DEBUG定義 [デバッグ用]
#define DEBUG_RMC											// DEBUG定義 [デバッグ用]
#define DEBUG_VTG											// DEBUG定義 [デバッグ用]
#define DEBUG_ZDA											// DEBUG定義 [デバッグ用]
//----------------------------------------------------------------------------------------------//


// Service Consumer stub headers
// <rtc-template block="consumer_stub_h">
#include "intellirobotStub.h"

// </rtc-template>

using namespace RTC;

class GpsService
  : public RTC::DataFlowComponentBase
{
 public:
  GpsService(RTC::Manager* manager);
  ~GpsService();

	// The initialize action (on CREATED->ALIVE transition)
	// formaer rtc_init_entry()
	virtual RTC::ReturnCode_t onInitialize();

  // The finalize action (on ALIVE->END transition)
  // formaer rtc_exiting_entry()
  // virtual RTC::ReturnCode_t onFinalize();

  // The startup action when ExecutionContext startup
  // former rtc_starting_entry()
  // virtual RTC::ReturnCode_t onStartup(RTC::UniqueId ec_id);

  // The shutdown action when ExecutionContext stop
  // former rtc_stopping_entry()
  // virtual RTC::ReturnCode_t onShutdown(RTC::UniqueId ec_id);

	// The activated action (Active state entry action)
	// former rtc_active_entry()
	virtual RTC::ReturnCode_t onActivated(RTC::UniqueId ec_id);

	// The deactivated action (Active state exit action)
	// former rtc_active_exit()
	virtual RTC::ReturnCode_t onDeactivated(RTC::UniqueId ec_id);

	// The execution action that is invoked periodically
	// former rtc_active_do()
	virtual RTC::ReturnCode_t onExecute(RTC::UniqueId ec_id);

  // The aborting action when main logic error occurred.
  // former rtc_aborting_entry()
  // virtual RTC::ReturnCode_t onAborting(RTC::UniqueId ec_id);

  // The error action in ERROR state
  // former rtc_error_do()
  // virtual RTC::ReturnCode_t onError(RTC::UniqueId ec_id);

  // The reset action that is invoked resetting
  // This is same but different the former rtc_init_entry()
  // virtual RTC::ReturnCode_t onReset(RTC::UniqueId ec_id);

  // The state update action that is invoked after onExecute() action
  // no corresponding operation exists in OpenRTm-aist-0.2.0
  // virtual RTC::ReturnCode_t onStateUpdate(RTC::UniqueId ec_id);

  // The action that is invoked when execution context's rate is changed
  // no corresponding operation exists in OpenRTm-aist-0.2.0
  // virtual RTC::ReturnCode_t onRateChanged(RTC::UniqueId ec_id);


 protected:
  // Configuration variable declaration
  // <rtc-template block="config_declare">
  std::string m_01_modemdevice;
  std::string m_02_baudrate;
  std::string m_03_stopbit;
  std::string m_04_rtscts;
  std::string m_05_serialport;
  std::string m_06_sendtime;
  std::string m_07_gga;
  std::string m_08_gll;
  std::string m_09_gns;
  std::string m_10_grs;
  std::string m_11_gsa;
  std::string m_12_gst;
  std::string m_13_gsv;
  std::string m_14_hdt;
  std::string m_15_rmc;
  std::string m_16_vtg;
  std::string m_17_zda;
  
  // </rtc-template>

  // DataInPort declaration
  // <rtc-template block="inport_declare">
  
  // </rtc-template>

  // DataOutPort declaration
  // <rtc-template block="outport_declare">
  TimedLegacyData m_LegacyData;
  OutPort<TimedLegacyData> m_LegacyDataOut;
  
  // </rtc-template>

  // CORBA Port declaration
  // <rtc-template block="corbaport_declare">
  
  // </rtc-template>

  // Service declaration
  // <rtc-template block="service_declare">
  
  // </rtc-template>

  // Consumer declaration
  // <rtc-template block="consumer_declare">
  
  // </rtc-template>

	private:
		int dummy;


		//-- [変数宣言] ----------------------------------------------------------------//

		// プログラム処理
		int i;											// カウンタ格納変数
		int j;											// カウンタ格納変数
		int count;										// カウンタ格納変数
		int err_flag;										// エラーフラグ格納変数
		int num;										// 番号格納変数
		int mes_num;										// メッセージ番号格納変数
		int message;										// メッセージモード格納変数
		int check;										// チェック格納変数
		int checksum;										// チェックサム格納変数
		int check_flag[11];									// チェックサムフラグ格納変数
		char checkbuf[3];									// チェックサムバッファ格納配列
		double now_time;									// 時間格納変数
		double timeout;										// タイムアウト格納変数
		unsigned long sec;									// タイムスタンプ格納変数 [sec]
		unsigned long nsec;									// タイムスタンプ格納変数 [nsec]

		// コンフィギュレーション
		char modemdevice[DATASIZE];								// COMアドレス格納配列
		char baudrate[DATASIZE];								// ボーレート格納配列
		char stopbit[DATASIZE];									// ストップビット格納配列
		char rtscts[DATASIZE];									// ハードウェアハンドシェイク格納配列
		char serialport[DATASIZE];								// シリアルポート格納配列
		char sendtime[DATASIZE];								// 測位更新間隔格納配列
		char mes_gga[DATASIZE];									// モード設定格納配列 [GGA]
		char mes_gll[DATASIZE];									// モード設定格納配列 [GLL]
		char mes_gns[DATASIZE];									// モード設定格納配列 [GNS]
		char mes_grs[DATASIZE];									// モード設定格納配列 [GRS]
		char mes_gsa[DATASIZE];									// モード設定格納配列 [GSA]
		char mes_gst[DATASIZE];									// モード設定格納配列 [GST]
		char mes_gsv[DATASIZE];									// モード設定格納配列 [GSV]
		char mes_hdt[DATASIZE];									// モード設定格納配列 [HDT]
		char mes_rmc[DATASIZE];									// モード設定格納配列 [RMC]
		char mes_vtg[DATASIZE];									// モード設定格納配列 [VTG]
		char mes_zda[DATASIZE];									// モード設定格納配列 [ZDA]

		// シリアル通信
		int fd;											// ファイルディスクリプタ格納変数
		int res;										// 受信文字数格納変数
		int err;										// エラー格納変数
		unsigned long int num_cflag;								// cflag用引数格納変数
		char buf[BUFSIZE];									// 受信データ格納配列
		char cbuf[BUFSIZE];									// チェック用データ格納配列
		char send[BUFSIZE];									// 送信データ格納配列
		struct sigaction saio;									// シグナル受信時動作設定格納構造体
		struct termios oldtio;									// 初期ポート設定格納構造体
		struct termios newtio;									// 新規ポート設定格納構造体

		// 受信バッファ
		char gga[16][DATASIZE];									// GGAメッセージ格納配列
		char gll[9][DATASIZE];									// GLLメッセージ格納配列
		char gns[13][DATASIZE];									// GNSメッセージ格納配列 [GNGNS]
		char gp_gns[13][DATASIZE];								// GNSメッセージ格納配列 [GPGNS]
		char gl_gns[13][DATASIZE];								// GNSメッセージ格納配列 [GLGNS]
		char gp_grs[16][DATASIZE];								// GRSメッセージ格納配列 [GPGRS]
		char gl_grs[16][DATASIZE];								// GRSメッセージ格納配列 [GLGRS]
		char gp_gsa[19][DATASIZE];								// GSAメッセージ格納配列 [GPGSA]
		char gl_gsa[19][DATASIZE];								// GSAメッセージ格納配列 [GLGSA]
		char gst[10][DATASIZE];									// GSTメッセージ格納配列
		char gp_gsv[3][21][DATASIZE];								// GSVメッセージ格納配列 [GPGSV]
		char gl_gsv[3][21][DATASIZE];								// GSVメッセージ格納配列 [GLGSV]
		char hdt[4][DATASIZE];									// HDTメッセージ格納配列
		char rmc[14][DATASIZE];									// RMCメッセージ格納配列
		char vtg[11][DATASIZE];									// VTGメッセージ格納配列
		char zda[8][DATASIZE];									// ZDAメッセージ格納配列

		//------------------------------------------------------------------------------//


};


extern "C"
{
  void GpsServiceInit(RTC::Manager* manager);
};

#endif // GPSSERVICE_H
