#!/bin/sh

# -bpython		: Pythonコンポーネントコード生成プログラム
# -bvcproject		: VC++プロジェクトファイル生成プログラム
# -bcxx			: C++コンポーネントコード生成プログラム
#
# --module-name		: モジュール名
# --module-desc		: モジュールの説明
# --module-version	: モジュールのバージョン
# --module-vendor	: モジュールのベンダ
# --module-category	: モジュールのカテゴリ
# --module-comp-type	: コンポーネントの型
# --module-act-type	: アクティビティタイプ
# --module-max-inst	: コンポネントインスタンスの最大数
#
# --inport		: 入力ポート定義
# --outport		: 出力ポート定義
# --service-idl		: サービスプロバイダIDLパス
# --service		: サービスプロバイダ定義
# --consumer-idl	: サービスコンシューマIDLパス
# --consumer		: サービスプロバイダ定義
# --config		: コンフィグレーションセット定義

rtc-template -bcxx \
	--module-name=GpsService \
	--module-desc='Service for LEGACY-E+' \
	--module-version=1.0.0 \
	--module-vendor=IRS \
	--module-category=Device \
	--module-comp-type=DataFlowComponent \
	--module-act-type=SPORADIC \
	--module-max-inst=1 \
	--outport=LegacyData:TimedLegacyData \
	--consumer-idl=irs.idl \
	--config=01_modemdevice:std::string:/dev/ttyS0 \
	--config=02_baudrate:std::string:115200 \
	--config=03_stopbit:std::string:1 \
	--config=04_rtscts:std::string:on \
	--config=05_serialport:std::string:/dev/ser/b \
	--config=06_sendtime:std::string:0.1 \
	--config=07_gga:std::string:on \
	--config=08_gll:std::string:on \
	--config=09_gns:std::string:on \
	--config=10_grs:std::string:on \
	--config=11_gsa:std::string:on \
	--config=12_gst:std::string:on \
	--config=13_gsv:std::string:on \
	--config=14_hdt:std::string:on \
	--config=15_rmc:std::string:on \
	--config=16_vtg:std::string:on \
	--config=17_zda:std::string:on
